package com.yice.webadmin.app.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.github.pagehelper.Page;
import com.yice.common.core.base.dao.BaseDaoMapper;
import com.yice.common.core.base.service.BaseService;
import com.yice.common.core.object.MyRelationParam;
import com.yice.common.core.util.MyModelUtil;
import com.yice.common.sequence.wrapper.IdGeneratorWrapper;
import com.yice.webadmin.app.dao.ModelEstimateMapper;
import com.yice.webadmin.app.model.ModelEstimate;
import com.yice.webadmin.app.model.ModelTask;
import com.yice.webadmin.app.model.ModelVersion;
import com.yice.webadmin.app.service.ModelEstimateService;
import com.yice.webadmin.app.service.ModelTaskService;
import com.yice.webadmin.app.service.ModelVersionService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;

/**
 * 模型评估数据操作服务类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Slf4j
@Service("modelEstimateService")
public class ModelEstimateServiceImpl extends BaseService<ModelEstimate, Long> implements ModelEstimateService {

    @Autowired
    private ModelEstimateMapper modelEstimateMapper;
    @Autowired
    private ModelTaskService modelTaskService;
    @Autowired
    private IdGeneratorWrapper idGenerator;
    @Autowired
    private ModelVersionService modelVersionService;

    /**
     * 返回当前Service的主表Mapper对象。
     *
     * @return 主表Mapper对象。
     */
    @Override
    protected BaseDaoMapper<ModelEstimate> mapper() {
        return modelEstimateMapper;
    }

    /**
     * 保存新增对象。
     *
     * @param modelEstimate 新增对象。
     * @return 返回新增对象。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public ModelEstimate saveNew(ModelEstimate modelEstimate) {
        modelEstimate.setTaskStatus(0);
        modelEstimateMapper.insert(this.buildDefaultValue(modelEstimate));
        ModelVersion modelVersion = this.modelVersionService.getById(modelEstimate.getModelVersionId());
        ModelTask modelTask = new ModelTask();
        modelTask.setVersionId(modelVersion.getVersionId());
        modelTask.setTaskType(1);
        modelTask.setTaskStatus(0);
        modelTask.setModelId(modelVersion.getModelId());
        modelTask.setModelVersion(modelVersion.getModelVersion());
        modelTask.setVersionName(modelVersion.getVersionName());
        modelTask.setTaskId(modelEstimate.getTaskId());
        this.modelTaskService.saveNew(modelTask);
        return modelEstimate;
    }

    /**
     * 利用数据库的insertList语法，批量插入对象列表。
     *
     * @param modelEstimateList 新增对象列表。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveNewBatch(List<ModelEstimate> modelEstimateList) {
        if (CollUtil.isNotEmpty(modelEstimateList)) {
            modelEstimateList.forEach(this::buildDefaultValue);
            modelEstimateMapper.insertList(modelEstimateList);
        }
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public ModelEstimate saveNewWithRelation(ModelEstimate modelEstimate, JSONObject relationData) {
        this.saveNew(modelEstimate);
        this.saveOrUpdateOneToOneRelationData(modelEstimate, relationData);
        return modelEstimate;
    }

    /**
     * 更新数据对象。
     *
     * @param modelEstimate         更新的对象。
     * @param originalModelEstimate 原有数据对象。
     * @return 成功返回true，否则false。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean update(ModelEstimate modelEstimate, ModelEstimate originalModelEstimate) {
        MyModelUtil.fillCommonsForUpdate(modelEstimate, originalModelEstimate);
        // 这里重点提示，在执行主表数据更新之前，如果有哪些字段不支持修改操作，请用原有数据对象字段替换当前数据字段。
        UpdateWrapper<ModelEstimate> uw = this.createUpdateQueryForNullValue(modelEstimate, modelEstimate.getTaskId());
        return modelEstimateMapper.update(modelEstimate, uw) == 1;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean updateWithRelation(
            ModelEstimate modelEstimate, ModelEstimate originalModelEstimate, JSONObject relationData) {
        // modelEstimate 为空的时候，无需修改主表数据。
        if (modelEstimate != null && !this.update(modelEstimate, originalModelEstimate)) {
            return false;
        }
        this.saveOrUpdateOneToOneRelationData(originalModelEstimate, relationData);
        return true;
    }

    private void saveOrUpdateOneToOneRelationData(ModelEstimate modelEstimate, JSONObject relationData) {
        // 对于一对一新增或更新，如果主键值为空就新增，否则就更新，同时更新updateTime和updateUserId。
        ModelTask modelTask = relationData.getObject("modelTask", ModelTask.class);
        if (modelTask != null) {
            modelTask.setTaskId(modelEstimate.getTaskId());
            modelTaskService.saveNew(modelTask);
            //  modelTaskService.saveNewOrUpdate(modelTask,
            //          modelTaskService::saveNew, modelTaskService::update);
        }
    }

    /**
     * 删除指定数据。
     *
     * @param taskId 主键Id。
     * @return 成功返回true，否则false。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean remove(Long taskId) {
        if (modelEstimateMapper.deleteById(taskId) == 0) {
            return false;
        }
        modelTaskService.remove(taskId);
        return true;
    }

    /**
     * 获取单表查询结果。由于没有关联数据查询，因此在仅仅获取单表数据的场景下，效率更高。
     * 如果需要同时获取关联数据，请移步(getModelEstimateListWithRelation)方法。
     *
     * @param filter  过滤对象。
     * @param orderBy 排序参数。
     * @return 查询结果集。
     */
    @Override
    public List<ModelEstimate> getModelEstimateList(ModelEstimate filter, String orderBy) {
        return modelEstimateMapper.getModelEstimateList(filter, orderBy);
    }

    /**
     * 获取主表的查询结果，以及主表关联的字典数据和一对一从表数据，以及一对一从表的字典数据。
     * 该查询会涉及到一对一从表的关联过滤，或一对多从表的嵌套关联过滤，因此性能不如单表过滤。
     * 如果仅仅需要获取主表数据，请移步(getModelEstimateList)，以便获取更好的查询性能。
     *
     * @param filter          主表过滤对象。
     * @param modelTaskFilter 一对一从表过滤对象。
     * @param orderBy         排序参数。
     * @return 查询结果集。
     */
    @Override
    public List<ModelEstimate> getModelEstimateListWithRelation(ModelEstimate filter, ModelTask modelTaskFilter, String orderBy) {
        List<ModelEstimate> resultList =
                modelEstimateMapper.getModelEstimateListEx(filter, modelTaskFilter, orderBy);
        // 在缺省生成的代码中，如果查询结果resultList不是Page对象，说明没有分页，那么就很可能是数据导出接口调用了当前方法。
        // 为了避免一次性的大量数据关联，规避因此而造成的系统运行性能冲击，这里手动进行了分批次读取，开发者可按需修改该值。
        int batchSize = resultList instanceof Page ? 0 : 1000;
        this.buildRelationForDataList(resultList, MyRelationParam.normal(), batchSize);
        return resultList;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean updateStatusById(ModelEstimate modelEstimate) {
        ModelTask modelTask = this.modelTaskService.getById(modelEstimate.getTaskId());
        modelTask.setTaskStatus(modelEstimate.getTaskStatus());
        modelTask.setCompleteTime(new Date());
        modelTaskService.updateById(modelTask);
        return this.updateById(modelEstimate);
    }

    private ModelEstimate buildDefaultValue(ModelEstimate modelEstimate) {
        if (modelEstimate.getTaskId() == null) {
            modelEstimate.setTaskId(idGenerator.nextLongId());
        }
        MyModelUtil.fillCommonsForInsert(modelEstimate);
        return modelEstimate;
    }
}
